﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.MonthViewSingle;
using System.Diagnostics;

namespace WinTimeLineViewCrosOwnerSelectApp
{
    public partial class Form1 : Form
    {
      
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraCalendarInfo1.Owners.Add("Owner1", "Owner1");
            ultraCalendarInfo1.Owners.Add("Owner2", "Owner2");
            ultraCalendarInfo1.Owners.Add("Owner3", "Owner3");

            //ultraCalendarInfo1.Owners[1].AppointmentActionsEnabled
            Appointment app1 = new Appointment(DateTime.Now, DateTime.Now.AddMinutes(15));
            app1.Owner = ultraCalendarInfo1.Owners["Owner1"];
            app1.Description = "Just Appoitment";
            
            Appointment app2 = new Appointment(DateTime.Now, DateTime.Now.AddMinutes(15));
            app2.Owner = ultraCalendarInfo1.Owners["Owner2"];
            app2.Description = "Just Appoitment";
            
            Appointment app3 = new Appointment(DateTime.Now, DateTime.Now.AddMinutes(15));
            app3.Owner = ultraCalendarInfo1.Owners["Owner3"];
            app3.Description = "Just Appoitment";
            
            ultraCalendarInfo1.Appointments.AddRange(new Appointment[] { app1, app2, app3 });
           

            ultraTimelineView1.EnsureDateTimeVisible(DateTime.Now);
          
        }

      

        private void SelectAppointment(UIElement element)
        {
            
            if (element == null || element.Parent == null)
                return;
           
            if (element.Parent is Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)
                ((Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)element.Parent).Appointment.Selected = !((Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)element.Parent).Appointment.Selected;
            else
                SelectAppointment(element.Parent);
        }

        

        private void ultraTimelineView1_MouseClick(object sender, MouseEventArgs e)
        {
            
                Point p = ultraTimelineView1.PointToClient(Cursor.Position);
                UIElement el = ultraTimelineView1.UIElement.ElementFromPoint(p);
                SelectAppointment(el); 
        }

        private void ultraTimelineView1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                Point p = ultraTimelineView1.PointToClient(Cursor.Position);
                Appointment  app  = ultraTimelineView1.AppointmentFromPoint(p);
                if (app != null)
                {
                    AppointmentDialog dialog = new AppointmentDialog(ultraTimelineView1.CalendarInfo, app, true);
                    dialog.ShowDialog();
                }
                else
                {
                    Nullable<DateTime> date = ultraTimelineView1.DateTimeFromPoint(p);
                    Owner owner = ultraTimelineView1.OwnerFromPoint(p);
                    if (date != null && owner != null)
                    {
                        app = new Appointment(date.Value, date.Value.Add(ultraTimelineView1.PrimaryInterval.NormalSpan));
                        app.Owner = owner;
                        AppointmentDialog dialog = new AppointmentDialog(ultraTimelineView1.CalendarInfo, app,false);
                        dialog.ShowDialog();
                    }
                }
            }
        }
    }
}
